#ifndef SONG_H
#define SONG_H

#include "sentence.h"

class cUltraStarSong
{
public:
  cUltraStarSong( );
  virtual ~cUltraStarSong( );
  void ReadSong( const char *filename );
  int SetCurrentTime( float time );
  int GetNextSyllable( cSyllable & syll, int *status );
private:
  void Init(int realloc = 1 );
  void TrimR( char * );
  void MakeMp3FilePath( const char *filename );
  char *GetLineParam( char *line, char *out, int lengthMax );
  char *GetLineParamTxt( char *line, char *out, int lengthMax );
  void ParseHeaderLine( const char *line );
  void ParseBodyLine( char *line );
public:
  char m_title[256];
  char m_artiste[256];
  char m_mp3FileName[512];
  int m_BPM;
  int m_GAP;                    // milliseconds
  int m_relativeTime;
  cSentence *m_lstSentences;
  int m_nbSentences;
  int m_nbMaxSentences;
  int m_currentTime;
  int m_currentSentence;
};

#endif // SONG_H
